SystemOrganization addCategory: #'Fuel-Tests'!
SystemOrganization addCategory: #'Fuel-Core'!
SystemOrganization addCategory: #'Fuel-Core-Cluster'!

TestCase subclass: #FLSerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLSerializerTest methodsFor: 'tests' stamp: 'sd 9/8/2010 16:36'!
assertMaterializationOf: anObject

	self assertMaterializationOf: anObject is: (Set with: anObject)! !

!FLSerializerTest methodsFor: 'tests' stamp: 'sd 9/9/2010 14:05'!
assertMaterializationOf: anObject is: aCollection
	| aByteArray aSerializer materializedObjects |

	aSerializer := FLSerializer on: (ByteArray new: 1000) writeStream.
	aByteArray := aSerializer serialize: anObject.
	materializedObjects := (FLMaterializer on: aByteArray) materialize.

	self assert: aCollection size equals: materializedObjects size.
	self should: [ aCollection includesAllOf: materializedObjects ]! !

!FLSerializerTest methodsFor: 'tests' stamp: 'sd 9/8/2010 16:33'!
testByte

	self assertMaterializationOf: 4! !

!FLSerializerTest methodsFor: 'tests' stamp: 'sd 9/9/2010 15:55'!
testOrderedCollection
	| anOrderedCollection |
	anOrderedCollection := OrderedCollection with: 10 with: 20.
	self assertMaterializationOf: anOrderedCollection is: (Set with: 10 with: 20 with: anOrderedCollection).! !

!FLSerializerTest methodsFor: 'tests' stamp: 'sd 9/9/2010 01:54'!
testPoint
	self assertMaterializationOf: 10@20 is: (Set with: 10 with: 20 with: 10@20).! !

!FLSerializerTest methodsFor: 'tests' stamp: 'sd 9/9/2010 02:03'!
testRectangule
	| aRectangule objects |
	aRectangule  := 10@20 corner: 30@40.
	objects := Set new.
	objects add: 10.
	objects add: 20.
	objects add: 30.
	objects add: 40.
	objects add: 10@20.
	objects add: 30@40.
	objects add: (10@20 corner: 30@40).
	
	self assertMaterializationOf: aRectangule is: objects.! !

!FLSerializerTest methodsFor: 'tests' stamp: 'sd 9/8/2010 16:33'!
testSmallInteger

	self assertMaterializationOf: 4000.! !

!Integer methodsFor: '*Fuel' stamp: 'MD 9/2/2010 12:00'!
flSerializeWith: aSerializer

	^ aSerializer serializeInteger: self.! !

Object subclass: #FLClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 14:35'!
id
	"Answer an unique byte identifier"
	self subclassResponsibility ! !

!FLClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 17:49'!
materializeOn: aReadStream addTo: aCollection

	self subclassResponsibility ! !

!FLClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 17:49'!
serializeAll: aCollection on: aWriteStream

	self subclassResponsibility ! !

FLClusterSerializer subclass: #FLObjectClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 16:39'!
id

	^0! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/9/2010 13:51'!
materializeOn: aReadStream addTo: aCollection

	| instanceCount className class |
	className := aReadStream nextString.
	instanceCount := aReadStream nextWord.

	class := Smalltalk at: className asSymbol.
	instanceCount timesRepeat: 
		[aCollection add: class basicNew].! !

!FLObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/9/2010 13:51'!
serializeAll: aCollection on: aWriteStream
	
	aWriteStream nextStringPut: aCollection anyOne class name.
	aWriteStream nextWordPut: aCollection size.
! !

FLClusterSerializer subclass: #FLPrimitiveClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

FLPrimitiveClusterSerializer subclass: #FLByteClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLByteClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 14:33'!
id

	^1! !

!FLByteClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 17:50'!
materializeOn: aReadStream

	^ aReadStream nextByte
	! !

!FLByteClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 22:08'!
serialize: aByte on: aWriteStream

	aWriteStream putByte: aByte
	! !

!FLPrimitiveClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 17:50'!
materializeOn: aReadStream

	self subclassResponsibility ! !

!FLPrimitiveClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/9/2010 00:28'!
materializeOn: aReadStream addTo: aCollection

	| instanceCount |
	instanceCount := aReadStream nextWord.

	instanceCount timesRepeat: 
		[aCollection add: 
			(self materializeOn: aReadStream)].! !

!FLPrimitiveClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 22:08'!
serialize: aByte on: aWriteStream
	self subclassResponsibility! !

!FLPrimitiveClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 22:08'!
serializeAll: aCollection on: aWriteStream

	aWriteStream nextWordPut: aCollection size.
	aCollection do: [:instance| self serialize: instance on: aWriteStream ]! !

FLPrimitiveClusterSerializer subclass: #FLSmallIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLSmallIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 14:46'!
id

	^2! !

!FLSmallIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 17:50'!
materializeOn: aReadStream

	| hi lo |
	hi := aReadStream next.
	lo := aReadStream next.
	^ (hi bitShift: 8) + lo! !

!FLSmallIntegerClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 22:08'!
serialize: aSmallInteger on: aWriteStream

	aWriteStream nextPut: (aSmallInteger bitShift: -8).
	aWriteStream nextPut: (aSmallInteger bitAnd: 255).! !

FLClusterSerializer subclass: #FLVariableObjectClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLVariableObjectClusterSerializer methodsFor: 'as yet unclassified' stamp: 'sd 9/9/2010 16:30'!
id

	^3! !

Object subclass: #FLMaterializer
	instanceVariableNames: 'stream clusterSerializers materializedObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLMaterializer class methodsFor: 'creation' stamp: 'sd 9/8/2010 15:25'!
on: aByteArray

	| materializer |
	materializer:=self new.
	materializer stream: aByteArray readStream.
	^materializer.! !

!FLMaterializer methodsFor: 'private' stamp: 'sd 9/8/2010 15:47'!
clusterSerializerFor: id

	^clusterSerializers at: id.! !

!FLMaterializer methodsFor: 'initialize-release' stamp: 'sd 9/9/2010 14:03'!
initialize 

	materializedObjects := OrderedCollection new.
	
	clusterSerializers := Dictionary new.
	self register: FLObjectClusterSerializer new.
	self register: FLSmallIntegerClusterSerializer new.
	 ! !

!FLMaterializer methodsFor: 'materializing' stamp: 'sd 9/9/2010 14:03'!
materialize
	self materializeInstances.
	self materializeReferences.
	^ materializedObjects! !

!FLMaterializer methodsFor: 'materializing' stamp: 'sd 9/9/2010 14:04'!
materializeCluster
	| clusterSerializerId instanceCount clusterSerializer |
	clusterSerializerId := stream nextWord.
	clusterSerializer := self clusterSerializerFor: clusterSerializerId.
	clusterSerializer materializeOn: stream addTo: materializedObjects! !

!FLMaterializer methodsFor: 'materializing' stamp: 'sd 9/9/2010 01:38'!
materializeInstances

	| clusterCount |
	clusterCount := stream nextWord.
	clusterCount timesRepeat: [self materializeCluster].
! !

!FLMaterializer methodsFor: 'materializing' stamp: 'sd 9/9/2010 16:46'!
materializeReferences
	| referenceIndex referencedInstance |
	"TODO: Optimize skipping the primitive, ready, instances"
	"TODO: make this method less horrible!!"
	materializedObjects
		do: [ :instance |
			instance class isVariable
				ifTrue: [
					1 to: instance basicSize do: [ :index | 
						referenceIndex := stream nextWord.
						referencedInstance := materializedObjects at: referenceIndex.
						instance basicAt: index put: referencedInstance ]
					]
				ifFalse: [
					1 to: instance class instSize do: [ :index | 
						referenceIndex := stream nextWord.
						referencedInstance := materializedObjects at: referenceIndex.
						instance instVarAt: index put: referencedInstance ]
					]]! !

!FLMaterializer methodsFor: 'initialize-release' stamp: 'sd 9/8/2010 15:55'!
register: aClusterSerializer

	clusterSerializers at: aClusterSerializer id put: aClusterSerializer. ! !

!FLMaterializer methodsFor: 'accessing' stamp: 'sd 9/8/2010 15:23'!
stream: aStream
	stream:= aStream.! !

Object subclass: #FLReferencesAnalyzer
	instanceVariableNames: 'aDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLReferencesAnalyzer methodsFor: 'analysis' stamp: 'sd 9/9/2010 14:03'!
clusteredInstancesFor: anObject
	anObject accept: self.
	^ aDictionary! !

!FLReferencesAnalyzer methodsFor: 'initialize-release' stamp: 'MD 9/3/2010 11:20'!
initialize 
	aDictionary:= Dictionary new.! !

!FLReferencesAnalyzer methodsFor: 'visiting' stamp: 'sd 9/9/2010 14:03'!
visitObject: anObject
	(aDictionary 
		at: anObject class 
		ifAbsentPut: [ OrderedCollection new ]) add: anObject! !

Object subclass: #FLSerializer
	instanceVariableNames: 'stream clusterSerializerDict defaultClusterSerializer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLSerializer class methodsFor: 'as yet unclassified' stamp: 'sd 9/8/2010 14:59'!
on: aWriteStream

	| serializer |
	serializer := self new.
	serializer stream: aWriteStream.
	^serializer.! !

!FLSerializer methodsFor: 'private' stamp: 'sd 9/8/2010 15:58'!
clusterSerializerFor: aClass 
	
	^clusterSerializerDict at: aClass ifAbsent: [ defaultClusterSerializer ].! !

!FLSerializer methodsFor: 'initialize-release' stamp: 'sd 9/8/2010 16:38'!
initialize 
	defaultClusterSerializer := FLObjectClusterSerializer new.

	clusterSerializerDict := Dictionary new.
	clusterSerializerDict at: SmallInteger put: FLSmallIntegerClusterSerializer new.! !

!FLSerializer methodsFor: 'serializing' stamp: 'sd 9/9/2010 13:57'!
serialize: anObject 

	| clusteredInstances instanceIndexes |
	clusteredInstances:= FLReferencesAnalyzer new clusteredInstancesFor: anObject.
	instanceIndexes := Dictionary new.

	self serializeInstancesWith: clusteredInstances and: instanceIndexes.
	self serializeReferencesWith: clusteredInstances and: instanceIndexes.

	^self stream contents.! !

!FLSerializer methodsFor: 'private' stamp: 'sd 9/9/2010 13:58'!
serializeInstancesWith: clusteredInstances and: instanceIndexes
	"maybe, we will have to serialize keeping a specific order, but it's ok for now'"

	| serializer counter |
	stream nextWordPut: clusteredInstances keys size.
	counter := 1.
	clusteredInstances
		keysAndValuesDo: [ :class :instances | 
			serializer := self clusterSerializerFor: class.
			stream nextWordPut: serializer id.
			serializer serializeAll: instances on: stream.
			instances
				do: [ :instance | 
					instanceIndexes at: instance put: counter.
					counter := counter + 1 ] ]! !

!FLSerializer methodsFor: 'private' stamp: 'sd 9/9/2010 16:39'!
serializeReferencesWith: clusteredInstances and: instanceIndexes 
	| class size |
	
	"TODO: make this method not so horrible!!"
	clusteredInstances 
		do: [ :instances |
			class := instances anyOne class.
			class isVariable 
				ifTrue: [
					instances 
						do: [ :anInstance |
							1 to: anInstance basicSize do: [ :index |
							stream 	nextWordPut: (instanceIndexes at: (anInstance basicAt: index))]]
					] 
				ifFalse: [
					size := class instSize.
					instances 
						do: [ :anInstance |
							1 to: size do: [ :index |
							stream 	nextWordPut: (instanceIndexes at: (anInstance instVarAt: index))]]
					]].
	! !

!FLSerializer methodsFor: 'accessing' stamp: 'sd 9/8/2010 14:59'!
stream
	^ stream! !

!FLSerializer methodsFor: 'accessing' stamp: 'sd 9/8/2010 14:59'!
stream: anObject
	stream := anObject! !

Object subclass: #FuelBenchmarks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FuelBenchmarks methodsFor: 'as yet unclassified' stamp: 'sd 9/9/2010 15:37'!
fuelSerializer

^ FLSerializer on: (ByteArray new: 1000) writeStream.
! !

!FuelBenchmarks methodsFor: 'as yet unclassified' stamp: 'sd 9/9/2010 15:46'!
rectangleSet
	| rectangles |
	rectangles := OrderedCollection new.
	1 to: 65000 by: 4 do: [ :i | 
		rectangles add: (i@(i+1) corner: (i+2)@(i+3))].
	^rectangles.! !

!FuelBenchmarks methodsFor: 'as yet unclassified' stamp: 'sd 9/9/2010 15:39'!
referenceStream

^ ReferenceStream on: (RWBinaryOrTextStream with: (ByteArray new: 1000)).! !

!FuelBenchmarks methodsFor: 'as yet unclassified' stamp: 'sd 9/9/2010 15:52'!
spyFuelSerializationOf: anObject

	| serializer |
	serializer := self fuelSerializer.

	MessageTally spyOn: [
		10 timesRepeat: [
			serializer serialize: anObject]]! !

!FuelBenchmarks methodsFor: 'as yet unclassified' stamp: 'sd 9/9/2010 15:53'!
spyReferenceStreamSerializationOf: anObject

	| serializer |
	serializer := self referenceStream.

	MessageTally spyOn: [
		10 timesRepeat: [
			serializer nextPut: anObject]]! !

!Object methodsFor: '*Fuel-analysis' stamp: 'MD 9/3/2010 11:17'!
accept: aVisitor

	aVisitor visitObject: self.
	1 to:(self class instSize) do:[:n|
		(self instVarAt:n) accept: aVisitor].! !

!Object methodsFor: '*Fuel' stamp: 'MD 9/2/2010 15:48'!
flSerializeWith: aSerializer

	aSerializer serializeObject: self.! !
